package com.itko.lisa.ext.vse;

import java.util.List;

import com.itko.lisa.vse.stateful.protocol.tcp.delimiters.TCPDelimiter;

/**
 * MLLP delimiter.
 */
public class MLLPDelimiter implements TCPDelimiter
{
	private int mStartOfNextRequest = 1;
	private int mEndOfRequest = -1;

	/**
	 * No parameters.
	 */
	@Override
	public void configure(String arg0)
	{
		// no-op
	}

	@Override
	public String validate()
	{
		return null;
	}

	@Override
	public int getEndOfRequest()
	{
		return mEndOfRequest;
	}

	@Override
	public int getStartOfNextRequest()
	{
		return mStartOfNextRequest;
	}

	@Override
	public boolean locateRequest(List<Byte> bytes)
	{
		mEndOfRequest = -1;

		int size = bytes.size();
		if (size < 2) return false;

		// loop until we find the end of the request
		for (int i = mStartOfNextRequest; i < (size - 1); i++)
		{
			if (bytes.get(i).intValue() == 0x1c)
			{
				mEndOfRequest = i + 2;
				mStartOfNextRequest = 1;
				return true;
			}
		}

		return false;
	}
}
